package com.eactive.eai.batch.job.jobItem.dacom;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_DAC25_120 extends DefaultTelegram implements TelegramService
{
//    private Properties jobInfo;
	private int REAL_BYTE;         // 실 data byte수
    private String filename;
    private File file;
    private FileInputStream fin ;
    private byte[] fileHeader;
    private byte[] fileData;

    public SEND_DAC25_120() {  // 다른 전문과 달리 전문 번호가 없어 편의상 120번을 부여함
    }

    public boolean doExecute() {
    	try {
        	if (!setBlockAndSeqNO()) return false;
            //길이 필드 + TR CODE 향후 TCP/IP로 전환 될 것을 대비 하여 길이와 TR CODE를 하나의 필드로 간주 하여 처리 한다.
            compileField(0, "" + REAL_BYTE, this.al_FieldProps[0]);

            //<< 전문 완성

            return true;

		} catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
		}
    }

    public boolean doPreExecute() {
        if (!super.doPreExecute()) return false;
        return true;
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        return REAL_BYTE + 4;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return REAL_BYTE;
    }

    /**
     * 여기서는 파일을 닫는다.
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            batchDoc.getBatchMsg().setTelegramHeader(new String((byte[])this.al_Field.get(0)));
            batchDoc.getBatchMsg().setTelegramBody(new String(fileData));

            if ( getConditionTxt().equals(TelegramKeys.EOF)){
                //DB로그에 남길 파일 헤더,트레일러 내용 설정
                super.setFileHeaderAndTrailer(file);

                if ( fin != null ) {
                    fin.close();
                    fin = null;
                }
                logger.info("{}  doPostExecute called : file close", logHeader);
                long curSize = batchDoc.getBatchMsg().getBody().getCurFileSize();
                long totSize = batchDoc.getBatchMsg().getHeader().getFileSize();
                if ( curSize != totSize ){
                	logger.debug("[SEND_DAC25_120:doPostExecute]-->" + curSize + "/" + totSize );
                    String[] msgArgs = new String[1];
                    msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                    String errCode = "BECEAIFJI029";
                    Exception e = new Exception("체크파일에 명시된 건수와 DATA 파일의 건수가 맞지 않습니다. \n"+
                    		                    "확인 바랍니다.");  
                    String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                    this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                    logger.error( e.getMessage(), e);
                	return false;
                }
            }
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < REAL_BYTE) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);

            // 20060419 add by khs for 전송상태 확인
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return REAL_BYTE;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean setBlockAndSeqNO (){
        try {
        	if (!createFile()) {
                logger.error("{}  file open failed", logHeader);
                return false;
            }
//        	boolean isFirstRec = false;

            REAL_BYTE = 0;                     // data 버퍼에 현재까지 채워진 공간
            int bufferSize = batchDoc.getBatchMsg().getHeader().getPacketSize();   // data 버퍼의 크기
            fileData = new byte[bufferSize];
            //                              // 각 레코드의 크기
//            int newLineByteLen = 1;
//            try {
//            	Properties jobInfo = getJobInfo();
//            	newLineByteLen = Integer.parseInt(jobInfo.getProperty(TelegramKeys.MLINK_NEWLINE_LEN));
//                String hdrInfo = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
//                if ( hdrInfo.substring(65, 67).equals("LL")){
//                	newLineByteLen = Integer.parseInt(hdrInfo.substring(67, 68));
//                }
//    		} catch (Exception e) {}
//            int recSize = batchDoc.getBatchMsg().getHeader().getRecLen();
//            byte[] recBuffer = new byte[recSize];
//            for (int inx = 0; inx < recBuffer.length; inx++) {
//				recBuffer[inx] = ' ';
//			}
//            logger.debug("[SEND_DAC25_120]newLineByteLen-->" + newLineByteLen );
//            logger.debug("[SEND_DAC25_120]recSize-->" + recSize );
//            logger.debug("[SEND_DAC25_120]recBuffer.length-->" + recBuffer.length );
//            String fileLine = null;

            if (fileHeader != null ){
                int headerLen = fileHeader.length;
                System.arraycopy( fileHeader, 0, fileData, 0, headerLen);
                REAL_BYTE = headerLen;
                
                REAL_BYTE += fin.read(fileData, headerLen, fileData.length - headerLen );
//                file
//                logger.debug("[SEND_DAC25_120],REAL_BYTE-->" + REAL_BYTE);
//                bufferSize -= REAL_BYTE;
                batchDoc.getBatchMsg().setFileHeader(new String(fileHeader));
                fileHeader = null;
//                isFirstRec = true;
            }else{
            	REAL_BYTE = fin.read(fileData);
  
//            	byte[] sendSum = batchDoc.getBatchMsg().getBody().getSendBuffer();
//                if ( sendSum != null ){
//                    System.arraycopy( sendSum, 0, fileData, 0, sendSum.length);
//                    REAL_BYTE = sendSum.length;
//                    logger.debug("[SEND_DAC25_120],REAL_BYTE-->" + REAL_BYTE);
//                    bufferSize -= REAL_BYTE;
//                    batchDoc.getBatchMsg().getBody().setSendBuffer(null);
//                }
            }
//            while ( bufferSize > 0 ){
//                // 일단 한건 읽어 봅시다.
//                fileLine = fbr.readLine();
//                if ( fileLine == null ){ // 읽은게 없으면 빠져 나가고
//                    fbr.close(); // 다 읽었으면 포인터를 닫고
//                    fbr = null;
//                    setConditionTxt(TelegramKeys.EOF);
//                    break;
//                }
//
//                System.arraycopy( fileLine.getBytes(), 0, recBuffer, 0, Math.min(recSize,fileLine.getBytes().length ));
//                switch (newLineByteLen) {
//				case 1:
//					recBuffer[recSize-1] = '\n';
//					break;
//				case 2:
//					recBuffer[recSize-2] = '\r';
//					recBuffer[recSize-1] = '\n';
//					break;
//				default:
//					break;
//				}
//                
//                if ( isFirstRec ){
//                	String fileHeader = batchDoc.getBatchMsg().getFileHeader() + new String( recBuffer );
//                	batchDoc.getBatchMsg().setFileHeader(fileHeader);
//                	isFirstRec = false;
//                }
//                // 한레코드 복사
//
//                if ( bufferSize >= recSize ){  // 남음 버퍼 크기가 레코드 한건 보다 크다면
//                    System.arraycopy( recBuffer, 0, fileData, fileData.length - bufferSize, recSize);
//                    REAL_BYTE += recSize;
//                    logger.debug("[SEND_DAC25_120],REAL_BYTE-->" + REAL_BYTE);
//                    bufferSize -= recSize;
//                } else {
//                    System.arraycopy( recBuffer, 0, fileData, fileData.length - bufferSize, bufferSize);
//                    REAL_BYTE += bufferSize;
//                    logger.debug("[SEND_DAC25_120],REAL_BYTE-->" + REAL_BYTE);
//                    byte[] recBit = new byte[recSize-bufferSize];
//                    System.arraycopy( recBuffer, bufferSize, recBit, 0, recSize-bufferSize );
//                    batchDoc.getBatchMsg().getBody().setSendBuffer(recBit);
//                    bufferSize = 0;
//                }
//            }
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            if ( lnCurSize >= batchDoc.getBatchMsg().getHeader().getFileSize()){
            	setConditionTxt(TelegramKeys.EOF);
            	batchDoc.getBatchMsg().setFileTrailer(new String(fileData));
            }

            return true;

        } catch (Exception ex) {
            logger.error("{} ★★★★★ 송신 파일 데이터 READ 시 오류 발생 !! ★★★★★", logHeader, ex);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(ex.toString());
            return false;
        }
    }
    
    private boolean createFile()
    {
        try {
            fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );
            if ( fin != null ) return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        int headerLen = TelegramKeys.MLINK_HEADER_LEN;
        fileHeader = new byte[headerLen];
        for (int inx = 0; inx < headerLen - 2; inx++) {
            fileHeader[inx] = ' ';
        }

        //        헤더 구분 : <<NEHEAD>>
        System.arraycopy( "<<NEHEAD>>".getBytes(), 0, fileHeader, 0, 10);

        //        업무 구분 :  1
        System.arraycopy( "1".getBytes(), 0, fileHeader, 10, 1);

        //        자료 형태 :  텍스트 파일(N), BINARY 파일(B), 압축데이타(C)
        //        # 자료형태 알수 없음 따라서 항상 N 으로 표시
        System.arraycopy( "N".getBytes(), 0, fileHeader, 11, 1);

        //        파일 크기 :  BODY부분의 크기
        String strFileSize = makeZero( "" + ( batchDoc.getBatchMsg().getHeader().getFileSize() - TelegramKeys.MLINK_HEADER_LEN ), 10);
        System.arraycopy( strFileSize.getBytes(), 0, fileHeader, 12, 10);

        //        압축후 파일크기 :  압축후의 BODY부분의 크기
        System.arraycopy( strFileSize.getBytes(), 0, fileHeader, 22, 10);

        String hdrInfo = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
        //        송신자 ID :  송신자의 ID
        System.arraycopy( hdrInfo.getBytes(), 38, fileHeader, 32, 10);

        //        업체 구분:  송신자의 업체구분 코드
        //        정보 구분:  BODY의 정보구분 코드 (문서명)
        String infoGb = batchDoc.getBatchMsg().getHeader().getBizCode();
        System.arraycopy( infoGb.getBytes(), 0, fileHeader, 42, 5);

        //      예비 1 바이트
        //String reserve = " ";
        //System.arraycopy( reserve.getBytes(), 0, fileHeader, 47, 1);

        //        수신자수 :  BODY부분을 수신할 ec-Bank HiVAN ID의 수
        System.arraycopy( "001".getBytes(), 0, fileHeader, 48, 3);

        //        수신자 ID :
        System.arraycopy( hdrInfo.getBytes(), 48, fileHeader, 51, 10);
        //        레코드 구분자 :  CR, LF
        fileHeader[headerLen-2] = '\r';
        fileHeader[headerLen-1] = '\n';

        //요구송신 파일 Start DB로그
        try {
            LogUtil.setLogFileStart(batchDoc);
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            this.filename = fileDir+ File.separator + fileNm;
            this.file = new File(this.filename);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                logger.debug("{}  the File does not exist!!! ["+this.filename+"]", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }
            fin = new FileInputStream(file);
            BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID(),filename, fin );

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI021";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return false;
        }
        return true;
    }
}